package com.sample;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import com.sample.DroolsTest.Message;

public class DynamicTest {

	private static KieContainer kieContainer;
	private KieSession kieSession;
	private Callback callback = new Callback();

	@BeforeClass
	public static void initKieContainer() {
		KieServices kieServices = KieServices.Factory.get();
		kieContainer = kieServices.getKieClasspathContainer();
	}

	/*
	 * Load and initialize a new KieSession on every test.
	 */
	@Before
	public void initKieSession() {
    	kieSession = kieContainer.newKieSession("ksession-rules");
		kieSession.setGlobal("callback", callback);
	}
	@Test
	public void test() {
		String[] fireSequence = {"rule2", "rule1", "rule2", "rule1", "rule2"};
    	for (int i=0; i<5; i++) {
    		try {
	    		Message message = new Message();
	    		kieSession.insert(message);
	    		kieSession.fireAllRules();
	    		
	    		assertEquals(callback.getResult(), fireSequence[i]);
	    		Thread.sleep(1000);
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}

	}

}
